#ifndef CREATURELIB_EXPERIENCEGAINEVENT_HPP
#define CREATURELIB_EXPERIENCEGAINEVENT_HPP
#include "EventData.hpp"

namespace CreatureLib::Battling {
    class ExperienceGainEvent : public EventData {
        ArbUt::BorrowedPtr<Creature> _creature;
        uint32_t _previousExperience;
        uint32_t _newExperience;

    public:
        ExperienceGainEvent(const ArbUt::BorrowedPtr<Creature>& creature, uint32_t previousExp, uint32_t newExp)
            : _creature(creature), _previousExperience(previousExp), _newExperience(newExp) {}
        EventDataKind GetKind() const noexcept override { return EventDataKind ::ExperienceGain; }
        const ArbUt::BorrowedPtr<Creature>& GetCreature() const noexcept { return _creature; }
        uint32_t GetPreviousExperience() const noexcept { return _previousExperience; }
        uint32_t GetNewExperience() const noexcept { return _newExperience; }
    };
}

#endif // CREATURELIB_EXPERIENCEGAINEVENT_HPP
