#ifndef CREATURELIB_ATTACKUSEHISTORY_HPP
#define CREATURELIB_ATTACKUSEHISTORY_HPP
#include "../../Models/ExecutingAttack.hpp"
#include "HistoryElement.hpp"

namespace CreatureLib::Battling {
    class AttackUseHistory : public HistoryElement {
        std::unique_ptr<const ExecutingAttack> _attack;

    protected:
        void Clear() override {
            _attack.reset();
            HistoryElement::Clear();
        }

    public:
        AttackUseHistory(const ExecutingAttack* attack) : _attack(attack) {}

        HistoryElementKind GetKind() const noexcept override { return HistoryElementKind::AttackUse; }
        ArbUt::BorrowedPtr<const ExecutingAttack> GetAttack() const noexcept { return _attack; }
    };
}

#endif // CREATURELIB_ATTACKUSEHISTORY_HPP
