#ifndef CREATURELIB_BATTLESTATCALCULATOR_HPP
#define CREATURELIB_BATTLESTATCALCULATOR_HPP

#include "../../Library/StatisticSet.hpp"

namespace CreatureLib::Battling {
    // predeclare BattleCreature class
    class Creature;

    class BattleStatCalculator {
    public:
        virtual ~BattleStatCalculator() = default;

        virtual Library::StatisticSet<uint32_t> CalculateFlatStats(Creature* creature) const;
        virtual Library::StatisticSet<uint32_t> CalculateBoostedStats(Creature* creature) const;
        virtual uint32_t CalculateFlatStat(Creature* creature, Library::Statistic stat) const;
        virtual uint32_t CalculateBoostedStat(Creature* creature, Library::Statistic stat) const;
    };
}

#endif // CREATURELIB_BATTLESTATCALCULATOR_HPP
