#ifndef CREATURELIB_CREATUREINDEX_HPP
#define CREATURELIB_CREATUREINDEX_HPP

#include "Creature.hpp"

namespace CreatureLib::Battling {
    class CreatureIndex {
        uint8_t _side;
        uint8_t _creature;

    public:
        CreatureIndex() noexcept : _side(0), _creature(0) {}
        CreatureIndex(uint8_t side, uint8_t creature) noexcept : _side(side), _creature(creature) {}

        uint8_t GetSideIndex() const noexcept { return _side; }

        uint8_t GetCreatureIndex() const noexcept { return _creature; }

        bool operator==(const CreatureIndex& rhs) const noexcept {
            return (_side == rhs._side) && (_creature == rhs._creature);
        }

        bool operator!=(const CreatureIndex& rhs) const noexcept { return !operator==(rhs); }
    };
}

#endif // CREATURELIB_CREATUREINDEX_HPP
