#ifndef CREATURELIB_SCRIPTRESOLVER_HPP
#define CREATURELIB_SCRIPTRESOLVER_HPP

#include "Script.hpp"
#include "ScriptCategory.hpp"

namespace CreatureLib::Battling {
    class BattleLibrary;

    class ScriptResolver {
    public:
        virtual ~ScriptResolver() = default;

        virtual void Initialize([[maybe_unused]] BattleLibrary* library){};
        virtual Script* LoadScript([[maybe_unused]] ScriptCategory category,
                                   [[maybe_unused]] const ArbUt::StringView& scriptName) {
            return nullptr;
        };
    };
}

#endif // CREATURELIB_SCRIPTRESOLVER_HPP
