#ifndef CREATURELIB_SWITCHTURNCHOICE_HPP
#define CREATURELIB_SWITCHTURNCHOICE_HPP

#include "BaseTurnChoice.hpp"
namespace CreatureLib::Battling {
    class SwitchTurnChoice : public BaseTurnChoice {
        ArbUt::BorrowedPtr<Creature> _newCreature;

    public:
        SwitchTurnChoice(ArbUt::BorrowedPtr<Creature> user, ArbUt::BorrowedPtr<Creature> newCreature) noexcept
            : BaseTurnChoice(user), _newCreature(newCreature) {}

        TurnChoiceKind GetKind() const noexcept final { return TurnChoiceKind::Switch; }

        inline const ArbUt::BorrowedPtr<Creature>& GetNewCreature() const noexcept { return _newCreature; }
        size_t ScriptCount() const override { return GetUser()->ScriptCount(); }

    protected:
        void GetActiveScripts(ArbUt::List<ScriptWrapper>& scripts) override { GetUser()->GetActiveScripts(scripts); }
    };
}

#endif // CREATURELIB_SWITCHTURNCHOICE_HPP
